Bug 1894508 - gnutls still allows weak crypto settings
Summary: gnutls still allows weak crypto settings
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: gnutls
Version: 33
Hardware: Unspecified
OS: Unspecified
medium
unspecified
Target Milestone: ---
Assignee: Red Hat Crypto Team
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2020-11-04 11:33 UTC by Eric Elena
Modified: 2021-11-30 17:42 UTC (History)
6 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-11-30 17:42:04 UTC
Type: Bug


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Gitlab gnutls gnutls merge_requests 1352 0 None None None 2020-11-06 11:42:50 UTC

Description Eric Elena 2020-11-04 11:33:39 UTC
Description of problem:
gnutls in fedora 33 can still connect to a server over TLS using SHA1 signature. It should be forbidden as per https://fedoraproject.org/wiki/Changes/StrongCryptoSettings2

Version-Release number of selected component (if applicable):
gnutls.x86_64                          3.6.15-1.fc33

How reproducible:
System was upgraded from fedora 32.
$ gnutls-cli -V espaceclient.axa.fr:443
Processed 154 CA certificate(s).
Resolving 'espaceclient.axa.fr:443'...
Connecting to '171.18.34.198:443'...
- Certificate type: X.509
- Got a certificate list of 3 certificates.
- Certificate[0] info:
<snip>
- Certificate[1] info:
<snip>
- Certificate[2] info:
<snip>

- Status: The certificate is trusted. 
- Description: (TLS1.2-X.509)-(ECDHE-SECP256R1)-(RSA-SHA1)-(AES-256-GCM)
- Session ID: F8:F1:59:AD:06:1D:76:D1:B8:09:72:CF:62:5D:5C:C1:E4:4B:06:9D:2B:C5:BB:CA:21:47:3D:42:F8:6B:AA:B1
- Ephemeral EC Diffie-Hellman parameters
 - Using curve: SECP256R1
 - Curve size: 256 bits
- Version: TLS1.2
- Key Exchange: ECDHE-RSA
- Server Signature: RSA-SHA1
- Cipher: AES-256-GCM
- MAC: AEAD
- Options: safe renegotiation,
- Channel binding 'tls-unique': 2181e59d6a0fdac0bc6f862c
- Handshake was completed

- Simple Client Mode:

GET / HTTP/1.1
Host: espaceclient.axa.fr
User-Agent: Mozilla/5.0 (X11; Fedora; Linux x86_64; rv:82.0) Gecko/20100101 Firefox/82.0- Sent: 15 bytes
- Sent: 26 bytes

- Sent: 89 bytes

- Sent: 1 bytes
- Received[1448]: HTTP/1.1 406 Not Acceptable
Connection: close
Cache-Control: no-cache
Content-Type: text/html; charset=utf-8
Pragma: no-cache
Server: aws
Transfer-Encoding: chunked

4000
<!DOCTYPE html>
<snip>

Actual results:
It's possible to connect to the server and get an answer from it even though we can see that the server signature is RSA-SHA1.

Expected results:
The session should be dropped. Firefox cannot connect with the reason SSL_ERROR_UNSUPPORTED_HASH_ALGORITHM, openssl cannot connect either:
$ openssl s_client -connect espaceclient.axa.fr:443
CONNECTED(00000003)
depth=2 C = US, O = DigiCert Inc, OU = www.digicert.com, CN = DigiCert Global Root G2
verify return:1
depth=1 C = US, O = DigiCert Inc, CN = DigiCert EV RSA CA G2
verify return:1
depth=0 businessCategory = Private Organization, jurisdictionC = FR, jurisdictionST = \C3\8Ele-de-France, jurisdictionL = Paris, serialNumber = 572 093 920, C = FR, L = PARIS, O = AXA, OU = AXA, CN = espaceclient.axa.fr
verify return:1
139840200582976:error:1414D172:SSL routines:tls12_check_peer_sigalg:wrong signature type:ssl/t1_lib.c:1185:

Comment 1 Alexander Sosedkin 2020-11-05 11:29:04 UTC
I can confirm that on a clean Fedora 33 install, it also connects with
(TLS1.2-X.509)-(ECDHE-SECP256R1)-(RSA-SHA1)-(AES-256-GCM).

[root@fedora33 ~]# update-crypto-policies --show
DEFAULT
[root@fedora33 ~]# grep RSA-SHA1 /etc/crypto-policies/back-ends/gnutls.config
insecure-sig = RSA-SHA1

Comment 2 Daiki Ueno 2020-11-06 08:50:12 UTC
This is caused by the special case introduced by:
https://gitlab.com/gnutls/gnutls/-/commit/485f2551e68d1b4ee70be2960f0a241b4a2b9fb9

Despite the comment, the algorithm check is done after the addition of GNUTLS_VERIFY_ALLOW_BROKEN. The commit log is not very clear about the intention as well.

Comment 3 Ben Cotton 2021-11-04 16:19:10 UTC
This message is a reminder that Fedora 33 is nearing its end of life.
Fedora will stop maintaining and issuing updates for Fedora 33 on 2021-11-30.
It is Fedora's policy to close all bug reports from releases that are no longer
maintained. At that time this bug will be closed as EOL if it remains open with a
Fedora 'version' of '33'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 33 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 4 Ben Cotton 2021-11-30 17:42:04 UTC
Fedora 33 changed to end-of-life (EOL) status on 2021-11-30. Fedora 33 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.